/* 
 * Copyright (c) Service Management Integrations Limited, 2014 - 2018
 * All Rights Reserved.
 * NOTICE: All information contained herein is and remains the property of Service Management  Integrations Limited.  The intellectual and technical concepts contained herein are proprietary to Service Management Integrations Limited and are protected by copyright law.  Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained from Service Management Integrations Limited.
 */

(function scriptedWebServiceOperation(request, response) {

	var xmldoc = new XMLDocument("<Response></Response>");
	try {
		var strDisplayValues=request.display_value_set.replace(/\\\,/g,'#!!#');
		var displayValueSet=strDisplayValues.split(',');
		for(i=0;i<displayValueSet.length;i++) {
			displayValueSet[i]=displayValueSet[i].replace("#!!#",",");
		}
		var tableSet=request.table_set.split(',');
		var recordIDSet=request.record_id_set.split(',');
		var displayFieldSet=request.display_field_set.split(',');
		if(displayValueSet.length!=tableSet.length || displayValueSet.length!=recordIDSet.length || displayValueSet.length!=displayFieldSet.length) {
			throw new Error("The item counts are inconsistent[tables="+tableSet.length+", display fields="+displayFieldSet.length+", display values="+displayValueSet.length+",  record ids="+recordIDSet.length+"]");
		}
		var xmldoc = new XMLDocument("<Response></Response>");
		var results = xmldoc.createElement("ResultSet");
		for(i=0;i<displayValueSet.length;i++) {
			xmldoc.setCurrent(results);
			var result= xmldoc.createElement("result");
			xmldoc.setCurrent(result);
			xmldoc.createElement("record_id",recordIDSet[i]);
			try {
				var gr=new GlideRecord(tableSet[i]);
				gr.addQuery(displayFieldSet[i],displayValueSet[i]);
                                gr.orderByDesc('sys_updated_on')
				gr.query();
				if(gr.next()) {
					xmldoc.createElement("sys_id",gr.sys_id);
					if(gr.next())
						xmldoc.createElement("status","multimatch");
					else
						xmldoc.createElement("status","matched");
				}
				else {
					xmldoc.createElement("sys_id","");
					xmldoc.createElement("status","unmatched");
				}
			}
			catch(e) {
				xmldoc.createElement("sys_id","");
				xmldoc.createElement("status","error");
				xmldoc.createElement("status_msg",'Error: '+e);
				response.status_msg='Error: '+e;
			}
		}
	}
	catch(e){
		xmldoc.createElement("error",e);
	}
	response.soapResponseElement = xmldoc.getDocumentElement();

})(request, response);

