    /* 
     * Copyright (c) Service Management Integrations Limited, 2014 - 2018
     * All Rights Reserved.
     * NOTICE: All information contained herein is and remains the property of Service Management  Integrations Limited.  The intellectual and technical concepts contained herein are proprietary to Service Management Integrations Limited and are protected by copyright law.  Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained from Service Management Integrations Limited.
     */
    (function transformRow(source, target, map, log, isUpdate) {
        //##!MANAGED CODE!##
        ignore=true;
	
        try {
            var request = new sn_ws.RESTMessageV2();
            var instanceURL = gs.getProperty('glide.servlet.uri');
            var isRecordUpdate;
            if(source.target_sys_id.equals("-1")) {
                    //create (POST)
                    request.setHttpMethod('POST');
                    request.setEndpoint(instanceURL+'api/now/table/sn_hr_core_template');
                    isRecordUpdate=false;
            }
            else { //UPADTE (PUT)
                    request.setHttpMethod('PUT');
                    request.setEndpoint(instanceURL+"api/now/table/sn_hr_core_template/"+source.target_sys_id+"?sysparm_exclude_ref_link=true");
                    isUpdate=true;
            }

            //authentication from properties
            var user = gs.getProperty("x_semai_hrm.p_rest_user");
            var password =gs.getProperty("x_semai_hrm.p_rest_password");
            request.setBasicAuth(user,password);
            request.setRequestHeader("Accept","application/json");
            request.setRequestHeader('Content-Type','application/json');

            //build the request body
            var body="{";
            if(!source.active.nil())body+="\"active\":\""+source.active+"\",";
            if(!source.assign_to.nil())body+="\"assign_to\":\""+source.assign_to+"\",";
            if(!source.date_offset_quantity.nil())body+="\"date_offset_quantity\":\""+source.date_offset_quantity+"\",";
            if(!source.date_offset_type.nil())body+="\"date_offset_type\":\""+source.date_offset_type+"\",";
            if(!source.date_offset_units.nil())body+="\"date_offset_units\":\""+source.date_offset_units+"\",";
            if(!source.due_date_source.nil())body+="\"due_date_source\":\""+source.due_date_source+"\",";
            if(!source.global.nil())body+="\"global\":\""+source.global+"\",";
            if(!source.group.nil())body+="\"group\":\""+source.group+"\",";
            if(!source.link_element.nil())body+="\"link_element\":\""+source.link_element+"\",";
            if(!source.name.nil())body+="\"name\":\""+source.name.replace(/\"/g,"\\\"")+"\",";+"\",";
            if(!source.next.nil())body+="\"next\":\""+source.next+"\",";
            if(!source.next_child.nil())body+="\"next_child\":\""+source.next_child+"\",";
            if(!source.owning_group.nil())body+="\"owning_group\":\""+source.owning_group+"\",";
            if(!source.parent_case_table.nil())body+="\"parent_case_table\":\""+source.parent_case_table+"\",";
            if(!source.roles.nil())body+="\"roles\":\""+source.roles+"\",";
            if(!source.show_on_template_bar.nil())body+="\"show_on_template_bar\":\""+source.show_on_template_bar+"\",";
            if(!source.stand_alone.nil())body+="\"stand_alone\":\""+source.stand_alone+"\",";
            if(!source.sys_customer_update.nil())body+="\"sys_customer_update\":\""+source.sys_customer_update+"\",";
            if(!source.target_domain.nil())body+="\"sys_domain\":\""+source.target_domain.replace(/\"/g,"\\\"")+"\",";+"\",";
            if(!source.sys_name.nil())body+="\"sys_name\":\""+source.sys_name.replace(/\"/g,"\\\"")+"\",";+"\",";
            if(!source.sys_package.nil())body+="\"sys_package\":\""+source.sys_package+"\",";
            if(!source.sys_policy.nil())body+="\"sys_policy\":\""+source.sys_policy+"\",";
            if(!source.sys_replace_on_upgrade.nil())body+="\"sys_replace_on_upgrade\":\""+source.sys_replace_on_upgrade+"\",";
            log.info(source.target_scope.toString());
            if(!source.target_scope.nil())body+="\"sys_scope\":\""+source.target_scope+"\",";
            if(!source.table.nil())body+="\"table\":\""+source.table+"\",";
            if(!source.template.nil())body+="\"template\":\""+source.template.replace(/\"/g,"\\\"")+"\",";+"\",";
            if(!source.template_reference.nil())body+="\"template_reference\":\""+source.template_reference+"\",";
            if(!source.template_reference_field.nil())body+="\"template_reference_field\":\""+source.template_reference_field+"\",";
            if(!source.user.nil())body+="\"user\":\""+source.user+"\",";
            if(!source.view.nil())body+="\"view\":\""+source.view+"\",";
            if(!source.short_description.nil())body+="\"short_description\":\""+source.short_description.replace(/\"/g,"\\\"")+"\",";+"\",";
            body=body.slice(0,-1); //remove the final  comma 
            body+="}";
            body=body.replace(/[\n\r\t]/g,'');
            request.setRequestBody(body);
            var response = request.execute();
            if(response.haveError()) {
                    error=true;
                    error_message="["+ response.getErrorCode()+"] "+response.getErrorMessage();
            }
            else {
                    if(isRecordUpdate==false) {
                            status_message="inserted;"+response.getHeader("Location").replace(request.getEndpoint()+"/","");
                    }
                    else {
                            status_message="updated;"+source.target_sys_id;
                    }
            }
    }
    catch(e) {
            error=true;
            error_message=e.message+"\n"+e.stack;
    }
})(source, target, map, log, action==="update");


