/* 
 * Copyright (c) Service Management Integrations Limited, 2014 - 2018
 * All Rights Reserved.
 * NOTICE: All information contained herein is and remains the property of Service Management  Integrations Limited.  The intellectual and technical concepts contained herein are proprietary to Service Management Integrations Limited and are protected by copyright law.  Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained from Service Management Integrations Limited.
 */


(function transformRow(source, target, map, log, isUpdate) {
    //##!MANAGED CODE!##
    ignore = true;
	try {
		//Check if Journal entry Exists  
                var existingId=getExistingEntryID(source.field_name,source.parent_id,source.created_on,source.entry_text);
		if (existingId!=null) {
			status_message="skipped;" + existingId;
			return; //already exists
		}
		//create the journal entry record
		var grNewJournal = new GlideRecord('sys_journal_field');
		grNewJournal.initialize();
		grNewJournal.name = source.parent_table;
		grNewJournal.element_id = source.parent_id;
		grNewJournal.element = source.field_name;
		grNewJournal.value = source.entry_text;
		grNewJournal.sys_created_on = source.created_on;
		grNewJournal.sys_created_by = source.created_by;
		grNewJournal.autoSysFields(false);
		grNewJournal.insert();
		status_message="inserted;" + grNewJournal.sys_id;
		log.info("inserted journal entry for " + source.parent_id+"\n");
		
		//create the audit record
                if(source.add_audit_entry.toLowerCase()=="true") {
                    var grAudit = new GlideRecord('sys_audit');
                    grAudit.initialize();
                    grAudit.documentkey =source.parent_id;
                    grAudit.internal_checkpoint = GlideCounter.next('internal_checkpoint');
                    grAudit.tablename = source.parent_table;
                    grAudit.fieldname = source.field_name;
                    grAudit.newvalue = source.entry_text;
                    grAudit.oldvalue = "JOURNAL FIELD ADDITION";
                    grAudit.user = source.created_by;
                    grAudit.sys_created_by = source.created_by;
                    grAudit.sys_created_on = source.created_on;
                    grAudit.record_checkpoint=0;
                    grAudit.autoSysFields(false);  
                    grAudit.insert();
                    log.info("inserted audit entry for " + source.parent_id);
                    
                    var grHistory=new GlideRecord('sys_history_set');
                    grHistory.addQuery('id='+source.parent_id);
                    grHistory.query();
                    if(grHistory.next()) {
                        log.info('activity history deleted for '+ source.parent_id);
                        grHistory.deleteRecord();
                    }
                }
		
	}
	catch(e) {
		error=true;
		error_message="error: journal entry addition [ " + source.parent_id +","+source.field_name+"]\n"+e.message();
		log.info(error_message);
	}
	
	function getExistingEntryID(element, sysId, timestamp, v) {
		var journalGR = new GlideRecord("sys_journal_field");
		journalGR.addQuery('element', element);
		journalGR.addQuery('element_id', sysId);
		journalGR.addQuery('sys_create_on', timestamp);
		journalGR.addQuery('value', v);
		journalGR.setLimit(1);
		journalGR.query();

		if (journalGR.next()) {
			// found
			return journalGR.sys_id;
		}
		// not found, we can add
		return null;
	}

})(source, target, map, log, action==="update");