/* 
 * Copyright (c) Service Management Integrations Limited, 2014 - 2017
 * All Rights Reserved.
 * NOTICE: All information contained herein is and remains the property of Service Management  Integrations Limited.  The intellectual and technical concepts contained herein are proprietary to Service Management Integrations Limited and are protected by copyright law.  Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained from Service Management Integrations Limited.
 */
(function transformRow(source, target, map, log, isUpdate) {
	//##!MANAGED CODE!##
	ignore = true;
	// build our value with the additional text
	try {
		var myValue = "[" + source.target_created_on + "] :"+ source.target_created_by + "]\n" + source.value;


		// check if we added already
		if (isPresent(source.element, source.element_id, source.name, myValue)) {
			  // we already added this journal entry
				status_message="skipped;" + source.element_id;
			  return;
		}

		// get the target record, should never happen
		var targetGR = new GlideRecord(source.name);
		if (targetGR.get(source.element_id) == false) {
			  error=true;
			  error_message="Target For journal entry record not found []" + source.element_id + "]";
			  // handle target not found
			  return;
		}


		// set the journal entry
		targetGR[source.element] = myValue;
		targetGR.update();
		status_message="inserted;" + source.element_id;
	}
	catch(e) {
		log.info("error: journal entry addition [ " + source.element_id +","+source.element+"]");
		error=true;
		error_message="error: journal entry addition [ " + source.element_id +","+source.element+"]\n"+e.message();
	}
	
	function isPresent(element, sysId, tbl, v) {
		var journalGR = new GlideRecord("sys_journal_field");
		journalGR.addQuery('element', element);
		journalGR.addQuery('element_id', sysId);
		journalGR.addQuery('name', tbl);
		journalGR.addQuery('value', v);
		journalGR.setLimit(1);
		journalGR.query();

		if (journalGR.next()) {
			// found
			return true;
		}
		// not found, we can add
		return false;
	}


})(source, target, map, log, action==="update");

