/* 
 * Copyright (c) Service Management Integrations Limited, 2014 - 2018
 * All Rights Reserved.
 * NOTICE: All information contained herein is and remains the property of Service Management  Integrations Limited.  The intellectual and technical concepts contained herein are proprietary to Service Management Integrations Limited and are protected by copyright law.  Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained from Service Management Integrations Limited.
 */
(function transformRow(source, target, map, log, isUpdate) {
	//##!MANAGED CODE!##
	ignore=true;
	var target_sys_id=null;
	try {
		if(source.itsmb_use_sys_id=='true') {
			//log.info('Use Sys ID');
			target.get(source.itsmb_source_id);
			if(target.isValidRecord()) {
				//log.info('id with matching id found');
				target_sys_id=source.itsmb_source_id;
				isUpdate=true;
			}
		}
		if(target_sys_id==null) {
			//log.info('check for mapping match');
			if(source.target_sys_id=='-1') {
				//log.info('no mapping match');
				target_sys_id='-1';
				if(source.itsmb_use_sys_id=='true') {
					target.setNewGuidValue(source.itsmb_source_id);
				}
				isUpdate=false;
			}
			else {
				//log.info('mapping match');
                                target.initialize();
                                target.get(source.target_sys_id);
				target_sys_id=source.target_sys_id;
				isUpdate=true;
			}
		}
		//source.sys_target_sys_id is now populated, apply the the update and create options
                if(isUpdate) {
                    switch(source.getValue('itsmb_update_option')) {
                        case 'SKIP': 
                            //log.info('skip update');
                            status_message="skipped;" + target_sys_id;
                            error_message="Target Entry exists and no updates allowed";
                            return;
                        case 'ERROR':
                            //log.info('error update');
                            status_message="error;" + target_sys_id;
                            error=true;
                            error_message="Target Entry exists and no updates allowed";
                            return;
                        default:
                            //log.info('do update');
                    }
                }
                else {
                    switch(source.getValue('itsmb_create_option')) {
                        case 'SKIP':
                            //log.info('skip create');
                            status_message="skipped;";
                            error_message="Target entry Does not exist and no inserts allowed";
                            return;
                        case 'ERROR': 
                            //log.info('error create');
                            status_message="error;";
                            error=true;
                            error_message="Target entry Does not exist and no inserts allowed";
                            return;
                        default:
                            //
                    }
                }
		if(!source.target_created_by.nil() || !source.target_created_on.nil() || !source.target_updated_by.nil() || !source.target_updated_on.nil() ||  !source.target_mod_count.nil()) {
			target.autoSysFields(false);
			if(source.target_created_by.nil()) {
				if(!isUpdate)target.sys_created_by=gs.getUserID();
			}
			else {
				target.sys_created_by=source.target_created_by;
			}
			if(source.target_created_on.nil()) {
				if(!isUpdate)target.sys_created_on=new GlideDateTime();
			}
			else {
				//target.sys_created_on=new GlideDateTime(source.getValue('target_created_on')).getValue();
                                setDateTimeValue(target.sys_created_on,source.target_created_on,'sys_created_on');
			}
			if(source.target_updated_on.nil()) {
				target.sys_updated_on=new GlideDateTime();
			}
			else {
                                setDateTimeValue(target.sys_updated_on,source.target_updated_on,'sys_updated_on');
			}
			if(source.target_updated_by.nil()) {
				target.sys_updated_by=gs.getUserID();
			}
			else {
				target.sys_updated_by=source.target_updated_by;
			}
			if(source.target_mod_count.nil()) {
				if(isUpdate)
					target.sys_mod_count=target.getValue('target_mod_count')+1;
			}
			else {
				target.sys_mod_count=source.target_mod_count;
			}
		}

		if(source.itsmb_run_workflow=='true') {
			target.setWorkflow(true);
		}
		else {
			target.setWorkflow(false);
		}
                
                //Field Mappings
//##REPLACE WITH FIELD MAPPINGS##
                //End of Field Mappings
		if(isUpdate) {
			target.update();
			status_message="updated;" + target.sys_id;
			//log.info("updated entry:" + target.sys_id);
		}
		else {
			target.insert();
			status_message="inserted;" + target.sys_id;
			//log.info("inserted entry :" + target.sys_id);
		}
                if(target.getLastErrorMessage()!=null) {
			error=true;
			error_message="error: scripted update / insert [ " + source.itsmb_source_id +"]\n"+target.getLastErrorMessage();
			log.info(error_message);
		}
	
	}
	catch(e) {
		error=true;
		error_message="error: scripted update / insert [ " + source.itsmb_source_id +"]\n"+e;
		log.info(error_message);
	}

})(source, target, map, log, action==="update");

//function to be used to set reference values
function setReferenceValue(targetElement,sourceElement,targetFieldName){
	if(sourceElement==null || targetElement==null)return;
	if(sourceElement.nil()) return;
	if(sourceElement=='#NULL#')
		targetElement.setValue('NULL');
	else {
		var val=sourceElement.getValue();
		try {
			if(val==null || val.length==32 && !val.contains(' ')) {
				targetElement.setValue(val);
			}
			else {
				var oldVal= targetElement.getDisplayValue();
				targetElement.setDisplayValue(val);

				if(targetElement.nil() || targetElement.getValue().length!=32 || targetElement.getValue().contains(' ')) {
					targetElement.setDisplayValue(oldVal);
				}
			}
		}
		catch(e) {
			throw '[' + val +'] is an invalid value for field \''+targetFieldName +'\'\n'+e;
		}
	}
}

//function to be used to setstring (or string compatible) values
function setValue(targetElement,sourceElement,targetFieldName){
	if(sourceElement==null || targetElement==null)return;
	if(sourceElement.nil()) return;
	if(sourceElement=='#NULL#')
		targetElement.setValue('NULL');
	else {
		var val=sourceElement.getValue();
		try {
			targetElement.setValue(val);
		}
		catch(e) {
			throw 'Error setting field \''+targetFieldName+'\' [' + val+']\n'+e;
		}
	}
}

//function to be used to datetime values
function setDateTimeValue(targetElement,sourceElement,targetFieldName){
    if(sourceElement==null || targetElement==null)return;
    if(sourceElement.nil()) return;
    if(sourceElement=='#NULL#')
        targetElement.setValue('NULL');
    else {
        var val=sourceElement.getValue();
        try {
            targetElement.setValue(new GlideDateTime(sourceElement).getValue());
        }
        catch(e) {
            throw 'Error setting date/time field \''+targetFieldName+'\' [' + val+']\n'+e;
        }
    }
}
    
//function to be used to set choice (or values with choices) values
function setChoiceValue(targetElement,sourceElement,targetFieldName){
	if(sourceElement==null || targetElement==null)return;
	if(sourceElement.nil()) return;
	if(sourceElement=='#NULL#')
		targetElement.setValue('NULL');
	else {
		var val=sourceElement.getValue();
		try {
			targetElement.setDisplayValue(val);
		}
		catch(e) {
			throw 'Error setting choice field \''+targetFieldName+'\' [' + val+']\n'+e;
		}
	}
}