/* 
 * Copyright (c) Service Management Integrations Limited, 2014 - 2018
 * All Rights Reserved.
 * NOTICE: All information contained herein is and remains the property of Service Management  Integrations Limited.  The intellectual and technical concepts contained herein are proprietary to Service Management Integrations Limited and are protected by copyright law.  Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained from Service Management Integrations Limited.
 */

(function transformRow(source, target, map, log, isUpdate) {
        //##!MANAGED CODE!##
	ignore = true;
        var variableName=null;
	try {
                //get the model id
                var modelID=null;
                var grDefinition=new GlideRecord('wf_activity_definition');
                grDefinition.addEncodedQuery('name='+ source.model_name);
                grDefinition.query();
                if(grDefinition.next()) {
                    modelID=grDefinition.sys_id;
                }
                else {
                    error=true;
                    error_message="error: workflow activity variable value migration [ " + source.parent_id +"]\nan activity definition for this model cannot be found ["+source.model_name+"]\n";
                    log.info(error_message);
                    return;
                }
                //get the variable
                var variableID=null;
                var variableName=null;
                var grVariable=new GlideRecord('wf_activity_variable');
                grVariable.addEncodedQuery('element='+source.activity_variable_name+"^model="+modelID);
                grVariable.query();
                if(grVariable.next()) {
                    variableID=grVariable.sys_id;
                    variableName=grVariable.name;
                }
                else {
                    error=true;
                    error_message="error: workflow activity variable value migration [ " + source.parent_id +"]\nan activity variable for this activity variable and model cannot be found ["+source.activity_variable_name+", "+modelID+"]\n";
                    log.info(error_message);
                    return;
                }
		var gr=new GlideRecord('sys_variable_value');
		var newEntry=false;
		gr.addEncodedQuery("document_key="+source.parent_id+"^variable="+variableID);
                gr.query();
		if(!gr.next()) {
			gr.initialize();
			newEntry=true;
		}
		gr.document=source.parent_table;
		gr.document_key=source.parent_id;
		gr.order=source.order;
		gr.value=source.value;
		gr.variable=variableID;
		if(newEntry) {
			gr.insert();
			status_message="inserted;" + gr.sys_id;
		}
		else {
			gr.update();
			status_message="updated;" + gr.sys_id;
		}
		log.info(status_message);
	}
	catch(e) {
		error=true;
		error_message="error: workflow activity variable value migration [" + variableName+"]\n"+e.message();
		log.info(error_message);
	}

})(source, target, map, log, action==="update");


